unit BDETReg;

interface

procedure Register;

implementation uses BDETable, TypInfo, Classes, DsgnIntf, SysUtils,
                    DB, DBTables;

{ TDBStringProperty }

type
  TDBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual; abstract;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

function TDBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TDBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

{ TTableNameProperty }

type
  TTableNameProperty = class(TDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

procedure TTableNameProperty.GetValueList(List: TStrings);
var Table: TTableItems;
begin
  Table := GetComponent(0) as TTableItems;
  Session.GetTableNames(Table.DatabaseName, '', True, False, List);
end;

procedure Register;
begin
  RegisterComponents ('BDE Lists',
                      [TDatabaseList,
                       TDriverList,
                       TStoredProcList,
                       TUserList,
                       TTableList,
                       TFamilyList,
                       TSecurityList,
                       TIndexList,
                       TFieldList,
                       TRefIntList,
                       TValCheckList]);
  RegisterPropertyEditor(TypeInfo(TFileName), TTableItems, 'TableName', TTableNameProperty);
end;


end.
 