USE Master
GO

IF EXISTS(select * from sysdatabases where name='SQLByStep')
	EXEC("drop database SQLByStep")
GO

CREATE DATABASE SQLByStep
ON
(
	Name = 'SQLByStep',
    FileName = 'C:\SQLByStep\data\SQLByStep.dat',
    Size = 1,
    MaxSize = 2
)
LOG ON
(
	Name = 'SQlByStep_Log',
	FileName = 'C:\SQLByStep\data\SQLByStep_Log.dat',
	Size = 1,
	MaxSize = 2
)
GO

USE SQLByStep
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name= 'Salespeople' AND type='U')
	DROP TABLE Salespeople
GO

CREATE TABLE Salespeople
(
	SNUM INT NOT NULL PRIMARY KEY, 
	SNAME CHAR(50) NOT NULL UNIQUE, 
	CITY CHAR(50) NOT NULL,
	COMM INT NOT NULL
)
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name= 'Customers' AND type='U')
	DROP TABLE Customers
GO

CREATE TABLE Customers
(
	CNUM INT NOT NULL PRIMARY KEY, 
	CNAME CHAR(50) NOT NULL UNIQUE,
	CITY CHAR(50) NOT NULL,
	RATING INT NULL,
	SNUM INT FOREIGN KEY REFERENCES Salespeople( SNUM )
)
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name= 'Orders' AND type='U')
	DROP TABLE Orders
GO

CREATE TABLE Orders
(
	ONUM INT NOT NULL PRIMARY KEY, 
	ODATE DATETIME NOT NULL, 
	AMT MONEY NOT NULL, 
	CNUM INT NOT NULL FOREIGN KEY REFERENCES Customers( CNUM ),
	SNUM INT NOT NULL FOREIGN KEY REFERENCES Salespeople( SNUM )
)
GO

INSERT INTO Salespeople ( SNUM, SNAME, CITY, COMM )
VALUES ( 1001, '', '', 12 )
INSERT INTO Salespeople ( SNUM, SNAME, CITY, COMM )
VALUES ( 1002, '', '', 13 )
INSERT INTO Salespeople ( SNUM, SNAME, CITY, COMM )
VALUES ( 1004, '', '', 11 )
INSERT INTO Salespeople ( SNUM, SNAME, CITY, COMM )
VALUES ( 1007, '', '', 15 )
INSERT INTO Salespeople ( SNUM, SNAME, CITY, COMM )
VALUES ( 1003, '', '', 10 )

GO

INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2001, '   ', '', 100, 1001 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2002, 'A   ', '', 200, 1003 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2003, ' ', '', 200, 1002 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2004, ' "  "', '', 300, 1002 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2006, 'Clemens', '', 100, 1001 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2008, ' "-"', '', 300, 1007 )
INSERT INTO Customers( CNUM, CNAME, CITY, RATING, SNUM )
VALUES ( 2007, ' ""', '', 100, 1004 )
GO

INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3001, 18.69, '10/03/1999', 2008, 1007 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3003, 767.19, '10/03/1999', 2001, 1001 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3002, 1900.10, '10/03/1999', 2007, 1004 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3005, 5160.45, '10/03/1999', 2003, 1002 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3006, 1098.16, '10/03/1999', 2002, 1007 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3009, 1713.23, '10/04/1999', 2002, 1003 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3007, 75.75, '10/04/1999', 2004, 1002 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3008, 4723.00, '10/05/1999', 2006, 1001 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3010, 1309.95, '10/06/1999', 2004, 1002 )
INSERT INTO Orders (ONUM, AMT, ODATE, CNUM, SNUM )
VALUES( 3011, 9891.88, '10/06/1999', 2006, 1001 )
GO
